"use strict";

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.some");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-own-property-descriptor");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var useUpdateSelection = function useUpdateSelection(props) {
  var originalSelection = props.selection;
  var selection = props.selection; // Make sure selection reacts to prop changes

  (0, _react.useEffect)(function () {
    if (!props.allowDuplicates) {
      // No duplicates, distinct
      var selectionValues = selection.map(function (item) {
        return item.value;
      });
      var newSelection = selection.filter(function (item, index) {
        return selectionValues.indexOf(item.value) === index;
      });
      if (newSelection.length !== selection.length) selection = newSelection;
    }

    if (!props.multiple && selection.length > 1) {
      // Single, only allow one selection
      selection = [selection[0]];
    }

    if (!props.creatable) {
      // Not creatable, only allow selections in the options
      var _newSelection = selection.filter(function (item) {
        return props.options.some(function (option) {
          return option.value === item.value;
        });
      });

      if (_newSelection.length !== selection.length) selection = _newSelection;
    }

    if (originalSelection !== selection) {
      props.onChange({
        target: {
          value: props.massageDataOut(selection.map(function (item) {
            return item.value;
          })),
          name: props.name
        }
      });
    }
  }, [props.allowDuplicates, props.multiple, props.creatable, props.options]);
};

var _default = useUpdateSelection;
exports.default = _default;